<?php

//Analyse du repertoire 

$rep=$argv[1];

$fich_param="$rep/params.php";
$fich_modele="$rep/modele.jclic";
$fich_sortie="$rep/$rep.jclic";

include("config.php");
include("inc_divers.php");
include("objets_jclic.class.php");
include("aff_modele.class.php");

//overide avec valeurs personalisees.
if (file_exists($fich_param)) include($fich_param);





function proceder_liste_mots($ar_mots, $lecteur_modele, $obj_activites)
{
	global $ar_patron_sequence;
	
	$compt_act=0;
	$compteur=0;
	$compt_id_act=0;

	foreach($ar_patron_sequence as &$act_ligne)
		if (isset($act_ligne["nom_act"])) $act_ligne["objet_act"]=$lecteur_modele->get_activite($act_ligne["nom_act"]);
	
	while ($compteur<sizeof($ar_mots))
	{	
	
		$activite=$ar_patron_sequence[($compt_act%sizeof($ar_patron_sequence))];
		
		if (isset($activite["avancer"]))
		{
			$compteur+=$activite["avancer"];
			$compt_act++;
			continue;
		}

		$elements_par_page=$activite["objet_act"]->nombre_elements;
		
		//calcul de l'offet
		$offset=0;
		if (isset($activite["decalage_elements"])) $offset=$activite["decalage_elements"];
		if ($compteur+$offset+$activite["max_elements"] > sizeof($ar_mots)) 
		{
			$differentiel=($compteur+$offset+$activite["max_elements"] - sizeof($ar_mots));
			$offset-=$differentiel;
			if(!(isset($activite["rotation_elements"]))) $activite["rotation_elements"]=0;
			$activite["rotation_elements"]=($activite["rotation_elements"]+$differentiel)%$activite["max_elements"];
		}
		if (isset ($activite["selection"])) if ($compteur+$offset+$activite["selection"]["echantillon"] > sizeof($ar_mots)) $offset-=($compteur+$offset+$activite["selection"]["echantillon"] - sizeof($ar_mots));
		if (($offset+$compteur)<0) $offset=0;
				
		if (isset($activite["selection"])) //selection des X meilleurs elements parmis les Y prochains elements
		{
			$mots_selection=array_values(array_slice($ar_mots, $compteur+$offset, $activite["selection"]["echantillon"]));
			$ar_tri=array(); //extraction des scores
			foreach ($mots_selection as &$ligne)
			{
				if (!isset($ligne["scores"][$activite["selection"]["critere"]])) $ligne["scores"][$activite["selection"]["critere"]]=0;
				if (isset($ligne["scores"])) array_push($ar_tri, $ligne["scores"][$activite["selection"]["critere"]]);
				else array_push($ar_tri, 0);
				
			}
			array_multisort($ar_tri, SORT_DESC, $mots_selection);
			
			$mots_tranche=array_values(array_slice($mots_selection, 0, $activite["max_elements"]));
		}
		else //selection des x prochain elements
			$mots_tranche=array_values(array_slice($ar_mots, $compteur+$offset, $activite["max_elements"]));
		
		//prise en compte inverser
			if (isset($activite["inverser"]))
				if ($activite["inverser"]=="oui") $mots_tranche=array_reverse($mots_tranche);
		
		//prise en compte repetition
		$mots_tranche_sans_ajouts=$mots_tranche;
		
		while((sizeof($mots_tranche)<$activite["max_elements"]*$activite["coef_repetition"]) || (sizeof($mots_tranche)%$elements_par_page))
			array_push($mots_tranche, $mots_tranche_sans_ajouts[rand(0, sizeof($mots_tranche_sans_ajouts)-1)]); 
			
		//prise en compte rotation
		if (isset($activite["rotation_elements"]))
		{
			$nb_rotation=$activite["rotation_elements"];
			while ($nb_rotation>0)
			{
				array_push($mots_tranche, array_shift($mots_tranche));
				$nb_rotation--;
			}
		}
		
		//prise en compte melanger	
		if (isset($activite["melanger"])) if ($activite["melanger"]=="oui") shuffle($mots_tranche);

		if (isset($activite["gere_avancement"])) if ($activite["gere_avancement"]=="oui") $compteur+=$activite["max_elements"];

		$compteur_dans_tranche=0;
		while ($compteur_dans_tranche<sizeof($mots_tranche))
		{
			$ar_mots_page=array_slice($mots_tranche, $compteur_dans_tranche, $elements_par_page);
			
			$compt_id_act++;
			$obj_activites->ajouter_activite($activite["nom_act"]."_$compt_id_act", $activite["objet_act"]->appliquer_aux_valeurs($ar_mots_page, $compt_id_act));
			$compteur_dans_tranche+=$elements_par_page;
		}
  
		$compt_act++;
	}
}

$compt_activite=0;


$lecteur_modele=new parseur_jclic($fich_modele);

//$test_act=$lecteur_modele->get_activite("testassoc");

$ma_biblio=new bibliotheque();
$ma_biblio->hydrade_depuis_rep($rep);

$mon_ensemble_activites=new ensemble_activites();

proceder_liste_mots($ma_biblio->get_structure_mots(), $lecteur_modele, $mon_ensemble_activites);



//definition des XML

$XML_ouverture="<JClicProject name=\"$rep\" version=\"0.1.3\">
";


$XML_parametres=" <settings>
  <title>$rep</title>
  <revision description=\"created\" date=\"".date("d/m/y")."\" />
  <descriptors />".
$ma_biblio->Generer_bloc_eventSound()
."</settings>\n";
//a ameliorer: recup les options projet du XML du modele et les ajouter ici

$XML_sequence=$mon_ensemble_activites->gen_bloc_sequence();

$XML_activites=$mon_ensemble_activites->get_xml_activites();

$XML_mediatheque=$ma_biblio->genere_XML_mediatheque();

$XML_fermeture="</JClicProject>";


if(!($hfichier=fopen($fich_sortie, "w"))) die ("ne peut ouvrir le fichier $fich_sortie");

fwrite($hfichier, $XML_ouverture);
fwrite($hfichier, $XML_parametres);
fwrite($hfichier, $XML_sequence);
fwrite($hfichier, $XML_activites);
fwrite($hfichier, $XML_mediatheque);
fwrite($hfichier, $XML_fermeture);


fclose($hfichier);

?>