<?php

// Cette classe sert a ouvrir un fichier jClic et à en extraire les différents éléments
class parseur_jclic
{
	private $ar_contenu_fichier;

	public function __construct($fichier)
	{
		global $opt_taille_max;
		
		$contenu_fichier="";

		
		try {
			$hzip=zip_open("$fichier.zip");
			while ($rsczip=zip_read($hzip)) 
				if (zip_entry_name($rsczip)=="modele.jclic") break;
			if (zip_entry_name($rsczip)!="modele.jclic") die("modele.jclic introuvable au sein de $fichier.zip");
			
			$contenu_fichier=zip_entry_read ($rsczip , $opt_taille_max );
			if ($opt_taille_max<zip_entry_filesize($rsczip)) die("fichier modele superieur a la taille limite!");
			zip_close($hzip);
		}
		catch (Exception $e) {
			echo "Exception reçue lors de la tentative d'ouverture de $fichier.zip:".  $e->getMessage();
			$handle=fopen($fichier, "r") or die ("tentative d'instancier la classe parseur_jclic avec le fichier $fichier: fichier inaccessible!");
			$contenu_fichier=fread ($handle , $opt_taille_max );
			if (!(feof($handle))) die("fichier modele superieur a la taille limite!");
			fclose($handle);

		}
		
	
		$this->ar_contenu_fichier=explode("\n", $contenu_fichier);
		//print_r($this->ar_contenu_fichier);
		unset($contenu_fichier);
	}
	
	public function get_activite($nom_activite)
	{
		$codeXML="";
		$trouve=0;
		
	
		foreach($this->ar_contenu_fichier as $ligne)
		{
			if (preg_match("/<activity.*name=\"$nom_activite\".*>/", $ligne))
			{
				$trouve=1;
				$ligne=str_replace($nom_activite, $nom_activite."_#NUM_ACT", $ligne);
			}
			
			if($trouve) $codeXML.=$ligne."\n";
			
			if (($trouve) && (preg_match("/<\\/activity>/", $ligne)))
				break;

		}
		
		if (!$trouve) die ("Activite \"$nom_activite\" introuvable dans le modele.");
		
		$ret_activite=new code_activite_jclic($codeXML);
		return($ret_activite);
		
	}
	
}


//Cette classe sert a gerer une activite extraitre avec parseur_jclic, jusqu'a appliquer un modele dessus
class code_activite_jclic
{
	public $code_XML_modele;
	protected $ar_liste_champs;
	protected $ar_liste_ligne_champs;
	public $nombre_elements;
	public $nombre_lignes_texte;
	
	
	function __construct($code_XML)
	{
		$this->ar_liste_champs=array();
		$this->ar_liste_ligne_champs=array();
	
		$this->code_XML_modele=$code_XML;
		$this->analyse_champs();
	}
	
	function analyse_champs()
	{
		preg_match_all("/#NOM[0-9]*/", $this->code_XML_modele, $elements);
		$this->ar_liste_champs["NOM"]=array_unique($elements[0]);
		
		preg_match_all("/#IMAGE[0-9]*/", $this->code_XML_modele, $elements);
		$this->ar_liste_champs["IMAGE"]=array_unique($elements[0]);

		preg_match_all("/#SON[0-9]*/", $this->code_XML_modele, $elements);
		$this->ar_liste_champs["SON"]=array_unique($elements[0]);
		
		preg_match_all("/#TEXTE[0-9]*/", $this->code_XML_modele, $elements);
		$this->ar_liste_champs["TEXTE"]=array_unique($elements[0]);

		$ar_ids=array_unique(array_merge(
			str_replace("#NOM", "", $this->ar_liste_champs["NOM"]),
			str_replace("#IMAGE", "", $this->ar_liste_champs["IMAGE"]),
			str_replace("#SON", "", $this->ar_liste_champs["SON"]),
			str_replace("#TEXTE", "", $this->ar_liste_champs["TEXTE"])
			));
		
		if (sizeof($ar_ids)>0)
			$this->nombre_elements=max($ar_ids);
		else $this->nombre_elements=0;
		
		
		
		preg_match_all("/#TEXTE[0-9]*.LIGNE[0-9]*/", $this->code_XML_modele, $elements);
		$this->ar_liste_ligne_champs=array_unique($elements[0]);
		
		$ar_ids=array_unique(preg_replace("/#TEXTE[0-9]*.LIGNE/", "", $this->ar_liste_ligne_champs));
		
		if (sizeof($ar_ids)>0)
			$this->nombre_lignes_texte=max($ar_ids);
		$this->nombre_lignes_texte=0;
	}
	
	function parse_champs_boucle($ar_mots)
	{
		$ar_lignes_parcourir= explode("\n", $this->code_XML_modele); //verif
		
		$ar_test_chp_dupl=array();
		
		$num_act_ligne=0;
		while ($num_act_ligne<sizeof($ar_lignes_parcourir))
		{

			$ar_info_champ=array();
			if (preg_match("/#TEXTE(?P<ID_CHAMP_TEXTE>[0-9]*).DUPL(?P<NUM_LIGNE_DUPL>[0-9]*)/", $ar_lignes_parcourir[$num_act_ligne], $ar_info_champ))
			{
				$recherche_ouverture_cell=$num_act_ligne;
				while((!(preg_match("/<cell.*>/", $ar_lignes_parcourir[$recherche_ouverture_cell]))) && ($recherche_ouverture_cell>0)) $recherche_ouverture_cell--;
				
				$recherche_fermeture_cell=$num_act_ligne;
				while((!(preg_match("/<\\/cell>/", $ar_lignes_parcourir[$recherche_fermeture_cell]))) && ($recherche_fermeture_cell>0)) $recherche_fermeture_cell++;
	
				$partion_a_repeter=array_splice($ar_lignes_parcourir, $recherche_ouverture_cell, $recherche_fermeture_cell-$recherche_ouverture_cell+1);
				
				//recherche setid
				$ar_params_setid=array();
				foreach ($partion_a_repeter as $act_ligne)
				if (preg_match("/#SETID.TEXTE(?P<ID_CHAMP_TEXTE>[0-9]*).LIGNESETID(?P<NUM_LIGNE_SETID>[0-9]*)/", $act_ligne, $ar_params_setid)) break;
				
				//recherche setimg
				$ar_params_setimg=array();
				foreach ($partion_a_repeter as $act_ligne)
				if (preg_match("/#SETIMG.TEXTE(?P<ID_CHAMP_TEXTE>[0-9]*).LIGNESETIMG(?P<NUM_LIGNE_SETIMG>[0-9]*)/", $act_ligne, $ar_params_setimg)) break;

				//recherche setson
				$ar_params_setson=array();
				foreach ($partion_a_repeter as $act_ligne)
				if (preg_match("/#SETSON.TEXTE(?P<ID_CHAMP_TEXTE>[0-9]*).LIGNESETSON(?P<NUM_LIGNE_SETSON>[0-9]*)/", $act_ligne, $ar_params_setson)) break;

				
				$elements_inseres=-1; //on part de -1 car on a enleve l'elt du modele!
				if(isset($ar_mots[$ar_info_champ["ID_CHAMP_TEXTE"]-1]["texte"])) 
				{
					$lignedeb=$ar_info_champ["NUM_LIGNE_DUPL"]-1;
					$ar_lignes_lues=explode("\n", $ar_mots[$ar_info_champ["ID_CHAMP_TEXTE"]-1]["texte"]);	
					$ar_elts=explode(";", $ar_lignes_lues[$lignedeb]);

					if (sizeof($ar_params_setid)>0) $ar_setid=explode(";", $ar_lignes_lues[$ar_params_setid["NUM_LIGNE_SETID"]-1]);
					if (sizeof($ar_params_setimg)>0) $ar_setimg=explode(";", $ar_lignes_lues[$ar_params_setimg["NUM_LIGNE_SETIMG"]-1]);
					if (sizeof($ar_params_setson)>0) $ar_setson=explode(";", $ar_lignes_lues[$ar_params_setson["NUM_LIGNE_SETSON"]-1]);

					foreach ($ar_elts as $element) 
					{
						if ($element=="") continue;
						$ar_a_inserer=str_replace("#TEXTE".$ar_info_champ["ID_CHAMP_TEXTE"].".DUPL".$ar_info_champ["NUM_LIGNE_DUPL"], $element, $partion_a_repeter);

						if (sizeof($ar_params_setid)>0) {
							$ar_a_inserer=str_replace("#SETID.TEXTE".$ar_info_champ["ID_CHAMP_TEXTE"].".LIGNESETID".$ar_params_setid["NUM_LIGNE_SETID"], "", $ar_a_inserer);
							$ar_a_inserer=str_replace("id=\"0\"", "id=\"".$ar_setid[$elements_inseres+1]."\"", $ar_a_inserer);							
						}
						
						if (sizeof($ar_params_setimg)>0) {
							$ar_a_inserer=str_replace("<p>#SETIMG.TEXTE".$ar_info_champ["ID_CHAMP_TEXTE"].".LIGNESETIMG".$ar_params_setimg["NUM_LIGNE_SETIMG"]."</p>", "", $ar_a_inserer);					
							foreach ($ar_a_inserer as &$ligne)
							{
								if (preg_match("/<cell /", $ligne))
									$ligne=str_replace(">", " image=\"".str_replace(" ", "", $ar_setimg[$elements_inseres+1])."\">", $ligne);
							}
						}
						
						if (sizeof($ar_params_setson)>0) {
							$ar_a_inserer=str_replace("<p>#SETSON.TEXTE".$ar_info_champ["ID_CHAMP_TEXTE"].".LIGNESETSON".$ar_params_setson["NUM_LIGNE_SETSON"]."</p>", "<media type=\"PLAY_AUDIO\" level=\"1\" file=\"".str_replace(" ", "", $ar_setson[$elements_inseres+1])."\" />", $ar_a_inserer);
						}
		
						
						//print_r($ar_a_inserer);
						array_splice($ar_lignes_parcourir, $recherche_ouverture_cell+(($elements_inseres+1)*sizeof($partion_a_repeter)), 0, $ar_a_inserer);
						$elements_inseres++;
					}
				}

				
				$recherche_ouverture_cells=$num_act_ligne;
				$ar_info_bloc=array();
 				while((!(preg_match("/<cells.*rows=\"(?P<NB_LIGNES>[0-9]*)\" cols=\"(?P<NB_COLONNES>[0-9]*)\".*>/", $ar_lignes_parcourir[$recherche_ouverture_cells], $ar_info_bloc))) && ($recherche_ouverture_cells>0)) $recherche_ouverture_cells--;
 				if($ar_info_bloc["NB_LIGNES"]>$ar_info_bloc["NB_COLONNES"])
 				{
					$ajout_lignes=round($elements_inseres/$ar_info_bloc["NB_COLONNES"], 0, PHP_ROUND_HALF_UP);
					$ajout_colonne=0;
 				}
 				else
  				{
					$ajout_lignes=0;
					$ajout_colonne=round($elements_inseres/$ar_info_bloc["NB_LIGNES"], 0, PHP_ROUND_HALF_UP);
 				}
 				$ar_lignes_parcourir[$recherche_ouverture_cells]=str_replace("rows=\"".$ar_info_bloc["NB_LIGNES"]."\"", "rows=\"".($ar_info_bloc["NB_LIGNES"]+$ajout_lignes)."\"", $ar_lignes_parcourir[$recherche_ouverture_cells]);
 				$ar_lignes_parcourir[$recherche_ouverture_cells]=str_replace("cols=\"".$ar_info_bloc["NB_COLONNES"]."\"", "cols=\"".($ar_info_bloc["NB_COLONNES"]+$ajout_colonne)."\"", $ar_lignes_parcourir[$recherche_ouverture_cells]);

 				// 
 				$recherche_ouverture_shaper=$num_act_ligne;
 				while((!(preg_match("/<shaper.*>/", $ar_lignes_parcourir[$recherche_ouverture_shaper]))) && ($recherche_ouverture_shaper>0)) $recherche_ouverture_shaper--;
				$ar_lignes_parcourir[$recherche_ouverture_shaper]=str_replace("rows=\"".$ar_info_bloc["NB_LIGNES"]."\"", "rows=\"".($ar_info_bloc["NB_LIGNES"]+$ajout_lignes)."\"", $ar_lignes_parcourir[$recherche_ouverture_shaper]);
 				$ar_lignes_parcourir[$recherche_ouverture_shaper]=str_replace("cols=\"".$ar_info_bloc["NB_COLONNES"]."\"", "cols=\"".($ar_info_bloc["NB_COLONNES"]+$ajout_colonne)."\"", $ar_lignes_parcourir[$recherche_ouverture_shaper]);

 				//print_r(array("ar_lignes_parcourir" => $ar_lignes_parcourir, "partion_a_repeter" => $partion_a_repeter, "recherche_ouverture_cell" => $recherche_ouverture_cell, "recherche_fermeture_cell" => $recherche_fermeture_cell, "recherche_ouverture_shaper" => $recherche_ouverture_shaper, "ar_info_champ" => $ar_info_champ, "ar_info_bloc" => $ar_info_bloc));

				
			}
			
			$num_act_ligne++;
		}
		
		return(implode("\n", $ar_lignes_parcourir));
	}
	
	function appliquer_aux_valeurs($ar_mots, $num_activite)
	{
// 		echo "------ START ------";
// 		print_r($ar_mots);
	
		$ar_mots=array_values($ar_mots); //reindexation
		
		$row=array();
		$row_ligne=array();
		
		$row["NUM_ACT"]=$num_activite;
		
		//premiere application: recherche des cellules a boucler
		$code_preparse=$this->parse_champs_boucle($ar_mots);
		
		$obj_modele=new aff_modele($code_preparse);
		
		//seconde application: les lignes des champs textes
		foreach($this->ar_liste_ligne_champs as $act_nom_champ)
		{
			$ar_params=array();
			preg_match("/#TEXTE(?P<ID_CHAMP_TEXTE>[0-9]*).LIGNE(?P<NUM_LIGNE>[0-9]*)/", $act_nom_champ, $ar_params);
		
		
			if(isset($ar_mots[$ar_params["ID_CHAMP_TEXTE"]-1]["texte"])) 
			{
				$ar_lignes_lues=explode("\n", $ar_mots[$ar_params["ID_CHAMP_TEXTE"]-1]["texte"]);
				if (isset($ar_lignes_lues[$ar_params["NUM_LIGNE"]-1])) $row_ligne[str_replace("#", "", $act_nom_champ)]=$ar_lignes_lues[$ar_params["NUM_LIGNE"]-1];
			}
		}
		
		
		$temp_XML=$obj_modele->appliquer_modele($row_ligne);
		$obj_modele2=new aff_modele($temp_XML);
		
		//print_r($row_ligne);
		
		//troiseme application: les champs
		foreach(str_replace("#NOM", "", $this->ar_liste_champs["NOM"]) as $achamp)
			if(isset($ar_mots[$achamp-1]["nom"])) $row["nom".$achamp]=$ar_mots[$achamp-1]["nom"];
		foreach(str_replace("#SON", "", $this->ar_liste_champs["SON"]) as $achamp)
			if(isset($ar_mots[$achamp-1]["son"])) $row["son".$achamp]=$ar_mots[$achamp-1]["son"];
		foreach(str_replace("#IMAGE", "", $this->ar_liste_champs["IMAGE"]) as $achamp)
			if(isset($ar_mots[$achamp-1]["image"])) $row["image".$achamp]=$ar_mots[$achamp-1]["image"];
		foreach(str_replace("#TEXTE", "", $this->ar_liste_champs["TEXTE"]) as $achamp)
			if(isset($ar_mots[$achamp-1]["texte"])) $row["texte".$achamp]=$ar_mots[$achamp-1]["texte"];
						
		//print_r($row);
						
		return($obj_modele2->appliquer_modele($row));
	}
	
}


//gere une bibliotheque: analyse d'un repertoire, generation liste mots des activites, ecriture de la biblio du fichier cible
class  bibliotheque
{

	protected $ar_biblio;	//sert a ecrire la bibliotheque du fichier cible
	protected $ar_bravo; 	//felicitation de fin dexercices (aleatoires)
	protected $ar_mots;	//liste des mots injectes dans les activites

	function __construct()
	{
		$this->ar_biblio=array();
		$this->ar_bravo=array();
		$this->ar_mots=array();
	}
	
	function hydrade_depuis_rep($rep)
	{
		global $ar_ext_image;
		global $ar_ext_son;
		global $ar_ext_texte;
		global $respect_casse;


		if (is_dir($rep)) {
		    if ($dh = opendir($rep)) {
			while (($file = readdir($dh)) !== false) {
			    if(filetype($rep ."/". $file)=="file")
			    {
				$nom=strtok($file, ".");
				if ($respect_casse==1) $nom=strtolower($nom);
				$extension=strtolower(strtok(""));

				//traitement differentie des "bravo"
				if (in_array($extension, $ar_ext_son) && (preg_match("/^bravo/", $nom)))
				{
					array_push($this->ar_biblio, $file);
					array_push($this->ar_bravo, $file);
					continue;
				}

				//fichiers qui ne vont pas dans des activites
				if ((preg_match("/^noauto_/", $nom)) || (preg_match("/^sys_/", $nom)))
				{
					array_push($this->ar_biblio, $file);
					continue;
				}

				if (in_array($extension, $ar_ext_image)) { $this->ar_mots[$nom]["image"]=$file; $this->ar_mots[$nom]["nom"]=$nom; array_push($this->ar_biblio, $file); }
				if (in_array($extension, $ar_ext_son)) { $this->ar_mots[$nom]["son"]=$file; $this->ar_mots[$nom]["nom"]=$nom; array_push($this->ar_biblio, $file); }
				if (in_array($extension, $ar_ext_texte)) 
				{ 
					$hfich_texte=fopen($rep ."/". $file, "r");
					$txt_brut=preg_replace("/\n$/", "", fread($hfich_texte, 16*1024));
					$txt_xml=str_replace("\n", "</p>\n<p>", $txt_brut);
					
					$this->ar_mots[$nom]["texte"]=$txt_brut;  //hack, precedemment, c'etait le texte xml qui etait insere....
					
					$this->ar_mots[$nom]["nom"]=$nom;
					fclose($hfich_texte);
				}

				}
			}
			closedir($dh);
		    }
		} else die("ne peut ouvrir le repertoire $rep");
		
		$this->definir_scores();
		array_multisort($this->ar_mots);
	}
	
	function definir_scores()
	{
		foreach($this->ar_mots as &$ligne)
		{
			$ar_str_scores=array();
			if (isset($ligne["texte"]))
			//echo $ligne["texte"];
			      if (preg_match_all("/critere: *(?P<critere>[[:alnum:]_.-]*) *score *= *(?P<score>[0-9]*)/", $ligne["texte"], $ar_str_scores))
			      {	
					$ligne["scores"]=array();
					foreach($ar_str_scores["critere"] as $cle => $val)
					$ligne["scores"][$ar_str_scores["critere"][$cle]]=$ar_str_scores["score"][$cle];
			      }

		}
	}
	
	function get_structure_mots()
	{
		return($this->ar_mots);
	}
	
	function Generer_bloc_eventSound()
	{
	  $XML_parametres="<eventSounds>\n";
	  if (in_array("sys_start.wav", $this->ar_biblio)) $XML_parametres.="<sound id=\"start\" file=\"sys_start.wav\" />\n";
	  if (in_array("sys_click.wav", $this->ar_biblio)) $XML_parametres.="<sound id=\"click\" file=\"sys_click.wav\" />\n";
	  if (in_array("sys_actionError.wav", $this->ar_biblio)) $XML_parametres.="<sound id=\"actionError\" file=\"sys_actionError.wav\" />\n";
	  if (in_array("sys_actionOk.wav", $this->ar_biblio)) $XML_parametres.="<sound id=\"actionOk\" file=\"sys_actionOk.wav\" />\n";
	  if (in_array("sys_finishedError.wav", $this->ar_biblio)) $XML_parametres.="<sound id=\"finishedError\" file=\"sys_finishedError.wav\" />\n";
	  if (in_array("sys_finishedOk.wav", $this->ar_biblio)) $XML_parametres.="<sound id=\"finishedOk\" file=\"sys_finishedOk.wav\" />\n";
	  $XML_parametres.="</eventSounds>";

		return($XML_parametres);
	}
	
	function genere_XML_mediatheque()
	{
	//generation mediatheque
		$XML_mediatheque="";
		$XML_mediatheque.="<mediaBag>
		";

		foreach ($this->ar_biblio as $afile)
			$XML_mediatheque.="<media name=\"$afile\" file=\"$afile\" />\n";
		
		$XML_mediatheque.="</mediaBag>";

		return($XML_mediatheque);
		
	}

}

//gere le code XML d'un ensemble d'activites ET la sequence
class ensemble_activites
{
	protected $XML_activites;
	protected $ar_sequence;
	
	function __construct()
	{
		$this->XML_activites="";
		$this->ar_sequence=array();
	}
	
	function ajouter_activite($nom_activite, $code_XML)
	{
		array_push($this->ar_sequence, $nom_activite);
		$this->XML_activites.="\n".$code_XML;
	}
	
	function gen_bloc_sequence()
	{
		global $delai_fin_activite;
	
		//Code sequence
		$XML_sequence="<sequence>
		";
		$compteur_seq=0;

		
		while ($compteur_seq<sizeof($this->ar_sequence))
		{

			if ($compteur_seq==0) $txtstart="id=\"start\"";
			else $txtstart="";
			$XML_sequence.="<item $txtstart name=\"".$this->ar_sequence[$compteur_seq]."\" delay=\"$delai_fin_activite\" />
			";

			$compteur_seq++;
		}
		$XML_sequence.=" </sequence>
		";

		return($XML_sequence);
	}
	
	function get_xml_activites()
	{
		return("<activities>
		".$this->XML_activites."
		</activities>");
	}
}


?>
